glibmm: Gio::IOStream Class Reference

glibmm 2.32.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Related Functions
Gio::IOStream Class Reference
Stream Classes

`#include <giomm/iostream.h>`

Inheritance diagram for Gio::IOStream:
[legend]

List of all members.

## Public Member Functions
virtual | ~IOStream ()
GIOStream* | gobj ()
| Provides access to the underlying C GObject.
const GIOStream* | gobj () const
| Provides access to the underlying C GObject.
GIOStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< InputStream > | get_input_stream ()
| Gets the input stream for this object.
Glib::RefPtr< OutputStream > | get_output_stream ()
| Gets the output stream for this object.
bool | close (const Glib::RefPtr< Cancellable >& cancellable)
| Closes the stream, releasing resources related to it.
bool | close ()
void | close_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
void | close_async (const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
bool | close_finish (const Glib::RefPtr< AsyncResult >& result)
| Closes a stream.
bool | is_closed () const
| Checks if a stream is closed.
bool | has_pending () const
| Checks if a stream has pending actions.
bool | set_pending ()
| Sets stream to have actions pending.
void | clear_pending ()
| Clears the pending flag on stream.
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable (const trackable &src)
trackable & | operator= (const trackable &src)
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | remove_destroy_notify_callback (void *data) const
void | notify_callbacks ()

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::IOStream > | wrap (GIOStream* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(* | DestroyNotify )(gpointer data)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
virtual | ~Object ()
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
virtual | ~ObjectBase ()=0
void | initialize (GObject* castitem)

## Detailed Description

Since glibmm 2.22:

## Constructor & Destructor Documentation

virtual Gio::IOStream::~IOStream | ( |  | ) |
| virtual

## Member Function Documentation

void Gio::IOStream::clear_pending | ( |  | ) |

Clears the pending flag on stream.

Since glibmm 2.22:

bool Gio::IOStream::close | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Closes the stream, releasing resources related to it.

This will also closes the individual input and output streams, if they are not already closed.

Once the stream is closed, all other operations will return IO_ERROR_CLOSED. Closing a stream multiple times will not return an error.

Closing a stream will automatically flush any outstanding buffers in the stream.

Streams will be automatically closed when the last reference is dropped, but you might want to call this function to make sure resources are released as early as possible.

Some streams might keep the backing store of the stream (e.g. a file descriptor) open after the stream is closed. See the documentation for the individual stream for details.

On failure the first error that happened will be reported, but the close operation will finish as much as possible. A stream that failed to close will still return IO_ERROR_CLOSED for all operations. Still, it is important to check and report the error to the user, otherwise there might be a loss of data as all data might not be written.

If cancellable is not `0`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error IO_ERROR_CANCELLED will be returned. Cancelling a close will still leave the stream closed, but some streams can use a faster close that doesn't block to e.g. check errors.

The default implementation of this method just calls close on the individual input/output streams.

Since glibmm 2.22:

Parameters:

  cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  `true` on success, `false` on failure.

bool Gio::IOStream::close | ( |  | ) |

void Gio::IOStream::close_async | ( | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

void Gio::IOStream::close_async | ( | const SlotAsyncReady& | slot,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

bool Gio::IOStream::close_finish | ( | const Glib::RefPtr< AsyncResult >& | result | ) |

Closes a stream.

Since glibmm 2.22:

Parameters:

  result | A AsyncResult.

Returns:
  `true` if stream was successfully closed, `false` otherwise.

Glib::RefPtr<InputStream> Gio::IOStream::get_input_stream | ( |  | ) |

Gets the input stream for this object.

This is used for reading.

Since glibmm 2.22:

Returns:
  A InputStream, owned by the IOStream. Do not free.

Glib::RefPtr<OutputStream> Gio::IOStream::get_output_stream | ( |  | ) |

Gets the output stream for this object.

This is used for writing.

Since glibmm 2.22:

Returns:
  A OutputStream, owned by the IOStream. Do not free.

GIOStream* Gio::IOStream::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

Reimplemented in Gio::SocketConnection, Gio::FileIOStream, Gio::UnixConnection, and Gio::TcpConnection.

const GIOStream* Gio::IOStream::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

Reimplemented in Gio::SocketConnection, Gio::FileIOStream, Gio::UnixConnection, and Gio::TcpConnection.

GIOStream* Gio::IOStream::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Reimplemented in Gio::SocketConnection, Gio::FileIOStream, Gio::UnixConnection, and Gio::TcpConnection.

bool Gio::IOStream::has_pending | ( |  | ) | const

Checks if a stream has pending actions.

Since glibmm 2.22:

Returns:
  `true` if stream has pending actions.

bool Gio::IOStream::is_closed | ( |  | ) | const

Checks if a stream is closed.

Since glibmm 2.22:

Returns:
  `true` if the stream is closed.

bool Gio::IOStream::set_pending | ( |  | ) |

Sets stream to have actions pending.

If the pending flag is already set or stream is closed, it will return `false` and set error.

Since glibmm 2.22:

Returns:
  `true` if pending was previously unset and is now set.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::IOStream > wrap | ( | GIOStream * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.